on initRearWindow
  global rwObj, gMaxColors, deskTopPattern, black
  if factory("RearWindow") = 0 then
    openXLib("RearWindow.XObj")
  end if
  initGlobals()
  if objectp(rwObj) then
    rwObj(mdispose)
  end if
  makeObjIfNeeded()
end

on releaseRearWindow
  global rwObj
  if objectp(rwObj) then
    rwObj(mdispose)
  end if
  closeXLib()
  set the mouseDownScript to EMPTY
  set the keyDownScript to EMPTY
end

on initGlobals
  global white, ltGray, gray, dkGray, black, deskTopPattern
  set white to -1
  set ltGray to -2
  set gray to -3
  set dkGray to -4
  set black to -5
  set deskTopPattern to -99
end

on coverDesktop patVar
  global rwObj
  makeObjIfNeeded()
  rwObj(mPatToWindow, patVar)
end

on unCoverDesktop
  global rwObj
  if objectp(rwObj) then
    rwObj(mdispose)
  end if
  unLoad()
end

on makeObjIfNeeded
  global rwObj
  if not objectp(rwObj) then
    set rwObj to RearWindow(mnew, "M")
    if value(rwObj) < 0 then
      alert("System error" && rwObj && "trying to create the RearWindow object in RAM (multiple-monitor config).")
      stopMovie()
      exit
    end if
    if the freeBlock < rwObj(mGetMemoryNeeded) then
      if objectp(rwObj) then
        rwObj(mdispose)
        set rwObj to RearWindow(mnew, "S")
      end if
      if value(rwObj) < 0 then
        alert("System error" && rwObj && "trying to create the RearWindow object in RAM (single-monitor config).")
        stopMovie()
        exit
      end if
      writeStageAndScreenBounds()
    end if
  end if
end
